//
// monty.hxx
//
// Leonard Janke
// August 1996

#ifndef _MONTY_HXX
#define _MONTY_HXX

#include "lmath.hxx"

class Monty
{
private:
  int sizeOfN;
  unsigned int nPrimeModB;
  unsigned int* n;
  unsigned int* rSquaredModN;
public:
  unsigned int* TScratch;

  Monty(const LInteger&);
  ~Monty();

  inline void MontyReduceTScratch();
  inline void MontyMultiply(const unsigned int*, const unsigned int*, 
                            unsigned int*);
  inline void MontySquare(const unsigned int*, unsigned int*);
  inline void ConvertToMonty(unsigned int*);
  inline void ConvertFromMonty(unsigned int*);
};

#include "monty.inl"

#endif
